#!/bin/sh

[ -z "$1" ] && exit 1 || URL=$1

DESTDIR=/tmp/download

[ ! -d $DESTDIR ] && mkdir -p $DESTDIR || rm -rf $DESTDIR/*

wget -t 1 --progress=bar -nd --waitretry 3 --wait 3 -P $DESTDIR  $URL 2>&1

[ "$?" != 0 ] && exit 1

echo
echo "Downloading RSA signed MD5sum"

RSAURL="$URL.md5.rsa"

wget -t 1 -nd --waitretry 3 --wait 3 -P $DESTDIR  $RSAURL 2>&1

if [ "$?" != 0 ]; then  # RSA MD5sum download FAILED
  name=`basename $URL`
  [ "$?" != 0 ] && exit 1
  cd $DESTDIR
  echo "Package:$name"
  echo "MD5:`md5sum $name`"
  echo "!RSA MD5sum FAILED,package originator UNKNOWN!"
else                                    # RSA MD5sum download SUCCESS
  name=`basename $URL`
  [ "$?" != 0 ] && exit 1
  cd $DESTDIR
  echo "Package:$name"
  echo -n "Signed MD5:"
  name=`basename $RSAURL`
  /bin/cat $name | /usr/bin/verify
  [ "$?" != 0 ] && exit 1
fi

exit 0
