#!/bin/sh

. /etc/network/net.conf
. /etc/network/if.conf

[ "$dhcp" -eq 0 ] && exit 0
[ "$netmode" = "bridge" ] && INTERFACE=br0 || INTERFACE=$wan

DEFAULTCFG=/etc/dhclient.conf
NEWCFG=/tmp/dhclient.conf
DHCP_LEASE_DIR=/var/lib/dhcp/dhclient.leases

ADDRESS=`grep fixed-address $DHCP_LEASE_DIR|tail -n 1|awk '{print $2}'`

cp $DEFAULTCFG $NEWCFG
echo >> $NEWCFG
[ ! -z "$ADDRESS" ] &&  echo "send dhcp-requested-address $ADDRESS" >> $NEWCFG

#kill dhclient
[ -f /var/run/dhclient.pid ] && kill -SIGTERM `cat /var/run/dhclient.pid` && rm /var/run/dhclient.pid

#start dhclient with configuration file $NEWCFG
ifconfig $INTERFACE 0.0.0.0 netmask 0.0.0.0 broadcast 255.255.255.255 up 2>/dev/null
dhclient-2.2.x -cf $NEWCFG $INTERFACE
